% read data
clear all; close all
dir='';
filename = 'alldata.txt';

rows=15;
fh = fopen ( fullfile(dir,filename), 'r+');
number=[];
for i=1:rows
    number = ['%f ' number];
end

C_text = textscan(fh, '%s', 17, 'delimiter', '|');
AllVar = textscan(fh, ['%s %s ' number ' %*[^\n]']);
Nuc = AllVar{1};
AA =  AllVar{2};

for i=1:rows
    Fr0(:,i) = AllVar{2+i};
end

% this is where replica are located
sets = {[1:5] [6:10] [11:15]};


N=numel(sets);   % total number of files
YMAX = [50, 50, 50];           % vertical scale for plots
  
cutoff=1;  % consider only reads that have 1 copy numbers on average

figure(1);
screen_size=get(0,'ScreenSize');
sW=screen_size(3);
sH=screen_size(4);
set(gcf,'Position',[sW*0.15 sH*0.2 sW*0.7 sH*0.3])

for ii=1:3 

        % load frequencies from different sets
        Fr = Fr0(:,sets{ii});

        Fr3=[];
        Fr4=[];
        
        NNN=mean(sum(Fr,1));
        
        for i=1:size(Fr,2)
            Fr3 = [Fr3 NNN*Fr(:,i) / sum(Fr(:,i))]; % normalized copy #
            Fr4 = [Fr4 Fr(:,i)];
        end
        mFr = (mean(Fr4,2));
        Fr3=Fr3(mFr>=cutoff,:); % discard reads that have <2 average copy
        
        NN=size(Fr3,1);
        GO=[];
        for i=1:NN
           GO(i)=sum ((Fr3(i,:) - mean(Fr3(i,:),2)).^2 / mean(Fr3(i,:),2));
        end
        subplot(1,N,ii);
        
        qqplot(chi2rnd(4,100000,1),GO(1:NN)); 
        xlim([0 25]);
        ylim([0 YMAX(ii)]);
end

figure(2);
set(gcf,'Position',[sW*0.15 sH*0.7 sW*0.85 sH*0.4])

for ii=1:N

        % load frequencies from different sets
        Fr = Fr0(:,sets{ii});

 
        % find average frequency
        mFr = mean(Fr,2);
 
        % Replace Fr = 0 by "fake" 0.3 value nad mFr = 0 by fake 0.1
        % it should not change the average but avoid problem with plotting
        % zeros on log-log scale
        % The zeros will appear as "string of dots" in the bot.left corner
        Fr(Fr==0)=0.3;
        mFr(mFr==0)=0.1;

        subplot(1,N,ii);
        
        X=[];
        Y=[]; 
        
        % combine data from multiple replicas in one vector
        for i=1:size(Fr,2);           
            X = [X; mFr];
            Y = [Y; Fr(:,i)];
        end
        
        % use colorplot function instead of plot
        h=colorplot(X, Y, [1 3 10 30 100 300 1000], [0 1 0], 1);
 
        % draw 1:1 line in blue color
        line([1 1e4], [1 1e4], 'color', [0 0 1]);
 
        % define the limits of axes
        xlim([0.1 1e5]);
        ylim([0.1 1e5]);
 
        % set axes to log, and tickmark properties
        set(get(h,'Parent'), 'YScale', 'log', 'XScale', 'log',...
            'TickDir', 'out','XMinorTick','on', 'YMinorTick','on');
end