% this file generates volcano plot and makes two text files that
% list statistically significant sequences.

% read data
clear all; close all
dir='';
filename = 'alldata.txt';

rows=15;5
fh = fopen ( fullfile(dir,filename), 'r+');
number=[];
for i=1:rows
    number = ['%f ' number];
end

C_text = textscan(fh, '%s', 17, 'delimiter', '|');
AllVar = textscan(fh, ['%s %s ' number ' %*[^\n]']);
Nuc = AllVar{1};
AA =  AllVar{2};

for i=1:rows
    Fr(:,i) = AllVar{2+i};
end

% this is where replica are located
sets = {[1:5] [6:10] [11:15]};


FrR=Fr;
IX=find(Fr==0);
FrR(IX)=0.3;


%% normalize the files by total frequency.
MMM=10^6;
for i=1:size(Fr,2)
    Fr(:,i)  = round(MMM * Fr(:,i)  / (sum(Fr(:,i))));
    FrR(:,i) = MMM * FrR(:,i) / (sum(Fr(:,i)));
end

Fr1=Fr(:,sets{1});
Fr2=Fr(:,sets{2});
Fr3=Fr(:,sets{3});

FrR1=FrR(:,sets{1});
FrR2=FrR(:,sets{2});
FrR3=FrR(:,sets{3});
%%

ratio  = log2 (mean(FrR1,2)./mean(FrR2,2));
ratio2 = log2 (mean(FrR1,2)./mean(FrR3,2));

[~,confi]  = ttest2(Fr1',Fr2',0.05,'both','unequal');
[~,confi2] = ttest2(Fr1',Fr3',0.05,'both','unequal');

limit=10^-8;
confi(confi<limit)=limit;
confi2(confi2<limit)=limit;

confi=-log10(confi);
confi2=-log10(confi2);

subplot(2,2,1);
plot(ratio,confi','.k'); hold on;
title('enrichment over negative selection');
xlim([-15 15]);
subplot(2,2,2);

plot(ratio2,confi2','.k'); hold on;
title('enrichment over naive library');
xlim([-15 15]);

line([-1 8],[-log10(0.05) -log10(0.05)]);
IX  = find(confi >=-log10(0.05) & ratio' >1 );  % one volcano
IX2 = find(confi2>=-log10(0.05) & ratio2'>1 );  % both volcanos

subplot(2,2,1);
plot(ratio(IX),confi(IX),'.r');
subplot(2,2,2);
plot(ratio2(IX2),confi2(IX2),'.r');


I = intersect(IX,IX2);
subplot(2,2,3);
plot(ratio2(I),ratio(I),'.k');
title('enrichment in naive library (X) vs negative selection (Y)');


disp(['Found ' num2str(numel(IX2)) '  parasites']);
hold off;

%% isolate selected sequences
NucS = char(Nuc(I,:));
AAS  = char(AA(I,:));
RatS = round(2.^(ratio2(I)));



savename1 = 'volcano2.txt';
savename2 = 'volcano2pep.txt';

SP  = char(32*ones(numel(RatS),5));
RET = char(10*ones(numel(RatS),1));

toSave  = [NucS SP AAS SP num2str(RatS) RET];
toSave2 = [AAS SP num2str(RatS) RET];
 
[~,IX]  = sort(RatS,'descend');
toSave  = toSave(IX,:);
toSave2 = toSave2(IX,:);

fprintf( fopen(savename1, 'wt'), '%s\r\n', toSave');
fprintf( fopen(savename2, 'wt'), '%s\r\n', toSave2');

fclose all;
